import csv
import sys

nodeIndices = {}

categoryColors = {"crossdomain": "WildStrawberry",
                  "social web" : "Gray40",
                  "usergeneratedcontent": "Tan",
                  "government": "Dandelion",
                  "geographic": "Blue",
                  "media": "Green",
                  "publications": "Orange",
                  "lifesciences": "Pink"
                  }


def createPajekNetworkFile(inputFileName, datasetFileName, outputFile):
	
    index = 1
    nodeLines = []
    
    with open(datasetFileName) as inputFile:
		
        print("Reading known graphs")
        csvreader = csv.reader(inputFile, delimiter='\t')
        for line in csvreader:
            
            nodeLines.append(str(index)+' "'+str(line[0])+'" ')
            nodeIndices[line[0]] = index
            index += 1
            
    inputFile.close
    print("Done")
    
    edgeLines = []
    
    with open(inputFileName) as inputFile:
		
        csvreader = csv.reader(inputFile, delimiter='\t')
        
        for row in csvreader:
			
            startNodeIndex = nodeIndices.get(row[0])
            targetNodeIndex = nodeIndices.get(row[2])
            
            if startNodeIndex == None or targetNodeIndex == None:
				
                print("Could not find index for Edge: "+row[0]+"  "+row[2])
                continue
                
            edgeLines.append(str(startNodeIndex)+" "+str(targetNodeIndex)+" "+str(row[4]))
            
    inputFile.close      
            
    with open(outputFile,'w') as outputFile:
		
        outputFile.write("*Vertices "+str(len(nodeLines))+'\n')
        outputFile.write('\n'.join(nodeLines))
        outputFile.write("\n*Arcs\n")
        outputFile.write('\n'.join(edgeLines))
        
    outputFile.close
    
    
if __name__ == '__main__':
	
    createPajekNetworkFile(sys.argv[1],sys.argv[2],sys.argv[3])
            
    
    
