#!/bin/bash
#Specifying Connection details
JavaQueryString='java -jar Query.jar'
#Server connection dertails
server='""'
username='""'
password='""'
crawlConnection="$server $username $password"
excludeSystemGraphs='DEFINE input:named-graph-exclude <http://www.openlinksw.com/schemas/virtrdf#> DEFINE input:named-graph-exclude <http://localhost:8890/sparql> DEFINE input:named-graph-exclude <http://localhost:8890/DAV/> '

baseFolder='./'
#File for itermediate results
ConnectionsIntermediateResults='connectionCandidates.tsv'
#Input file for dataset categories, predicates that are to be excluded etc.
categoryFile='./datasetCategories.tsv'
predicateExclusionFile='discardingProperties.txt'

#SPARQL queries
ConnectionsQueryString=$excludeSystemGraphs'select ?GRAPH, ?subject, ?predicate, ?object where {GRAPH ?GRAPH { ?subject ?predicate ?object. FILTER(isURI(?object) and ?predicate not in (<http://www.w3.org/1999/02/22-rdf-syntax-ns#type>,<http://dbpedia.org/property/externalLink>,<http://dbpedia.org/ontology/wikiPageExternalLink>,<http://dbpedia.org/property/externalLinks>,<http://www.w3.org/2006/http#connection>,<http://www.w3.org/2006/http#content-base>,<http://www.w3.org/2006/http#content-encoding>,<http://www.w3.org/2006/http#content-length>,<http://www.w3.org/2006/http#content-location>,<http://www.w3.org/2006/http#content-type>,<http://www.w3.org/2006/http#date>,<http://www.w3.org/2006/http#etag>,<http://www.w3.org/2006/http#expires>,<http://www.w3.org/2006/http#host>,<http://www.w3.org/2006/http#last-modified>,<http://www.w3.org/2006/http#link>,<http://www.w3.org/2006/http#mime-version>,<http://www.w3.org/2006/http#responseCode>,<http://www.w3.org/2006/http#server>))} }'


#output files
edgeFileName='datasetEdges.tsv'
degreeFileName='datasetDegrees.tsv'
edgesPredicatesFileName='edgesPredicates.tsv'
degreesPredicatesFileName='degreesPredicates.tsv'
predicateFileName='predicateConnections.tsv'
vocabFileName='vocabConnections.tsv'
NetworkFileName='GraphConnections.net'


if [ ! -s $baseFolder$ConnectionsIntermediateResults ]; then
	echo "Executing ConnectionQuery..."
	$JavaQueryString $crawlConnection "$ConnectionsIntermediateResults" "$ConnectionsQueryString"
	echo "Done"
fi
echo "Computing connections between PLDs..."
python3 "getDatasetConnections.py" $baseFolder$ConnectionsIntermediateResults "subject"  $categoryFile $baseFolder$edgeFileName $baseFolder$degreeFileName $baseFolder$edgesPredicatesFileName $baseFolder$degreesPredicatesFileName $baseFolder$predicateFileName $baseFolder$vocabFileName $predicateExclusionFile
python3 "CreatePajekNetworkFile.py" $baseFolder$ConnectionsResultFileName $baseFolder$NetworkFileName
echo "Done"
