import CrawlUtils
import sys
from collections import Counter
import gzip


if len(sys.argv) != 5:
    sys.exit()
dataFile=sys.argv[1]
predicateFile=sys.argv[2]
outputFile = sys.argv[3]
termFlag=int(sys.argv[4])
filterWords = set()
with open(predicateFile) as inputFile:
    for row in inputFile:
        filterWords.add(row.rstrip('\n'))
inputFile.close

counter = Counter()



with open(dataFile) as inputFile:
	
    rowNo=0
    
    for row in inputFile:
		
        rowNo += 1
        row.rstrip('\n')
        terms = CrawlUtils.parseQuad(row)
        
        if rowNo % 100000 == 0:
			
            print(str(rowNo))
            
        subjectDataset = CrawlUtils.getDataset(terms[0])
        contextDataset = CrawlUtils.getDataset(terms[3])
        
        if termFlag:
			
            predicateTerm = terms[1]
            
        else:
			
            predicateTerm = CrawlUtils.getVocabFromTerm(terms[1])
            
        if subjectDataset == contextDataset and predicateTerm in filterWords:
			
            counter[(terms[3], predicateTerm)] += 1
            
inputFile.close             
        
    


with open(outputFile,'w') as outputFile:
	
    for key, value in counter.items():
		
        outputFile.write(key[0]+'\t'+key[1]+'\n')
        
outputFile.close    
    
