import csv
import httplib2
import sys
import CrawlUtils
import random
import os.path

graphsAndDocs = {}
#List of graphs and their SWDs. For every graph. takes a sample of them and tries to find a well-known file
graphDocumentFile=""
#Where to put the void files
voidFiles=""
sampleList = set()
#first read list of PLDs
alreadyTested = set(

with open (graphDocumentFile) as inputFile:
	
    csvreader = csv.reader(inputFile, delimiter='\t')
    i = 0
    
    for row in csvreader:
		
        i += 1
        
        if i == 1:
			
            continue
            
        docSet= graphsAndDocs.get(row[0])
        
        if docSet == None:
			
            docSet = set()
 #       print (row)
 
        docSet.add(row[1])
        graphsAndDocs[row[0]] = docSet
        

for docs in graphsAndDocs.values():
	
    randomSample = random.sample(docs,10) if len(docs) >= 10 else list(docs)
    
    for doc in randomSample:
		
        inds= [i for i,c in enumerate(doc) if c=='/']
        
        if len(inds)  < 2:
			
            continue
            
        for i in reversed(inds[2:]):
			
            sampleList.add(doc[:i]+"/.well-known/void")

print("Number of samples: "+str(len(sampleList)))

#then crawl for every PLD its /.well-known/void location
with open(voidFiles+"responsesPositive.tsv", 'w') as outputFile:
	
    h = httplib2.Http(".cache", timeout=10)
    h.follow_all_redirects = True
    i = 0
   
    for searchAddress in sampleList:
        
        i += 1
        print(str(i)+" of "+str(len(sampleList))+" Searching for "+searchAddress+"  ", end="")
        
        try:
            resp, content = h.request(searchAddress, "GET",headers={'Accept': 'application/rdf+xml'})
            
            print(str(resp.status))
            
            if resp.status != 200:
               
                outputFile.write(searchAddress+'\t'+str(resp.status)+'\t\n')
               
                continue
            realURL = resp['content-location']
            filename = voidFiles+"/"+realURL.replace('/','|')
            print("Write to "+filename)
            outputFile.write(searchAddress+'\t'+str(resp.status)+'\t'+filename+'\n')
            with open(filename , 'wb') as f:
              
                f.write(content)
            
            f.close
        except:
            continue
outputFile.close
        
    
