#!/bin/bash
#Uses Query.jar from https://github.com/dwslab/dwslib to position virtuoso queries through JDBC
JavaQueryString='java -jar ./../Query.jar'
#Server configuration
instanceServer='""'
instanceServerUser='""'
instanceServerPassword'""'
crawlConnection="$instanceServer $instanceServerUser $instanceServerPassword"
vocabularyServeR='""'
vocabularyServerUser='""'
vocabularyServerPassword='""'
vocabConnection="$vocabularyServer $vocabularyServerUser $vocabularyServerPassword"
#code and output directories
codeDirectory='./code/'
solutionDirectory='./vocabularies/'
excludeSystemGraphs='DEFINE input:named-graph-exclude <http://www.openlinksw.com/schemas/virtrdf#> DEFINE input:named-graph-exclude <http://localhost:8890/sparql> DEFINE input:named-graph-exclude <http://localhost:8890/DAV/> '

equivalentDatasets='./../joinFirstCrawlAndTagCrawl/datasetsNSsAppearingInBothDatasets.tsv'
#File for datasets and categories
categoryFileName=''

datasetTermsFileName='TermsInDatasets.tsv'
PropertyClassTermsFileNameAll='PropertyClassTermsInDatasets.tsv'
PLDVocabUsageFileName='PLDVocabUsage.tsv'
vocabUsageByPLDCountFileName='vocabUsageByPLDCount.tsv'
vocabTermsFileName='vocabTerms.tsv'
vocabQueryString=$excludeSystemGraphs'SELECT ?GRAPH, ?term, count(*) as ?triplecount { {GRAPH ?GRAPH {?s a ?term.}} union {GRAPH ?GRAPH {?s ?term ?o. }} } group by ?GRAPH ?term'
propertyClassQueryString=$excludeSystemGraphs'SELECT ?GRAPH, ?class, ?property, count(*) as ?termcount { {GRAPH ?GRAPH {?s a ?class.}} union {GRAPH ?GRAPH {?s ?property ?o. }} } group by ?GRAPH ?class ?property'




echo "Executing Queries ..."
echo "1"
$JavaQueryString $crawlConnection "$DatasetTermsFileName" "$vocabQueryString"
echo "2"
$JavaQueryString $crawlConnection  "$PropertyClassTermsFileName" "$propertyClassQueryString"
echo "Done"

echo "Generating lists of vocabulary usage"
python3 "getVocabLists.py" "$solutionDirectory$DatasetTermsFileNameAll" "$categoryFileName" "$solutionDirectory$PLDVocabUsageFileName" "$solutionDirectory$vocabUsageByPLDCountFileName" "$solutionDirectory$vocabTermsFileName" "PLD" 
echo "Done"
